
//---------------------------------------------------------------------------
#pragma hdrstop
#include "Convter.h"
#pragma package(smart_init)
#include <vcl.h>
#define Samplerate 1
/*struct Pixelv
{
  int R_value,G_value,B_value,flag;  //RGBqxs,sX
};
  */
//Converter  Ω@¦vഫ  911223 Miles Wang
//---------------------------------------------------------------------------

#pragma package(smart_init)
TConverter *Convter;
__fastcall TConverter::TConverter()
{
  Group_Cnt=0;

}
//---------------------------------------------------------
__fastcall TConverter::~TConverter()
{

}
//---------------------------------------------------------
void __fastcall TConverter::Sep_RGB_Operation()
{
  int x_cnt,y_cnt,colorvalue;                      // Color to Gray Level Operation

  for(x_cnt=0;x_cnt<SizeX/Samplerate;x_cnt++)
    for(y_cnt=0;y_cnt<SizeY/Samplerate;y_cnt++)
    {
      colorvalue=CurrentFrame[x_cnt][y_cnt];
      Frame_RGB[x_cnt][y_cnt].R_value= GetRValue(colorvalue);        //R
      Frame_RGB[x_cnt][y_cnt].G_value=GetGValue(colorvalue);//G*0.57*256
      Frame_RGB[x_cnt][y_cnt].B_value= GetBValue(colorvalue);//B*0.13*256
    }

}
//---------------------------------------------------------
void __fastcall TConverter::GrayLevelOperation()
{
  int x_cnt,y_cnt,colorvalue;                      // Color to Gray Level Operation


  for(x_cnt=0;x_cnt<SizeX/Samplerate;x_cnt++)
    for(y_cnt=0;y_cnt<SizeY/Samplerate;y_cnt++)
    {
      colorvalue=CurrentFrame[x_cnt][y_cnt];
      buffer[x_cnt][y_cnt]=( GetRValue(colorvalue) * 77        //R*0.3*256
                           + GetGValue(colorvalue) * 151       //G*0.57*256
                           + GetBValue(colorvalue) * 28)/256;  //B*0.13*256
      Historgram[buffer[x_cnt][y_cnt]]++;
    }

}
//---------------------------------------------------------
void __fastcall TConverter::GetPicture(int x,int y,HWND Handle)
{
  // Get pixels value to CurrentFrame 
  int x_cnt,y_cnt,colorvalue;
  SizeX=x;
  SizeY=y;

  for(x_cnt=0;x_cnt<SizeX;x_cnt++)
    for(y_cnt=0;y_cnt<SizeY;y_cnt++)
    {
      colorvalue=GetPixel(Handle,x_cnt,y_cnt);
      CurrentFrame[x_cnt][y_cnt]=colorvalue;
    }
}
int __fastcall TConverter::Computer_Mean(int flag)
{
   int Countx,County;
   long int R_mean,G_mean,B_mean,Pixelnum;

   R_mean=0;
   G_mean=0;
   B_mean=0;
   for(Countx=0;Countx<SizeX;Countx++)
     for(County=0;County<SizeY;County++)
     {
       if(flag==Frame_RGB[Countx][County].flag)
       {
         R_mean+=Frame_RGB[Countx][County].R_value; //q֥[
         G_mean+=Frame_RGB[Countx][County].G_value; //q֥[
         B_mean+=Frame_RGB[Countx][County].B_value; //Ŧq֥[
       }
     }
   Pixelnum=SizeX*SizeY;
   R_mean/=Pixelnum;                          // 
   G_mean/=Pixelnum;                          // 
   B_mean/=Pixelnum;                          // Ŧ

   return(RGB(R_mean,G_mean,B_mean));         // C
}
void __fastcall TConverter::Set_Group_Cnt(int value)
{
    Group_Cnt=value;
}
int  __fastcall TConverter::Get_Group_Cnt()
{
  return(Group_Cnt);
}
void __fastcall TConverter::DrawPicture(int flag, HWND Handle)
{
  int x_cnt,y_cnt,colorvalue;
  for(x_cnt=0;x_cnt<SizeX/Samplerate;x_cnt++)
    for(y_cnt=0;y_cnt<SizeY/Samplerate;y_cnt++)
    {
      switch(flag)                                   // e
      {
        case 0:
           colorvalue=buffer[x_cnt][y_cnt];          //glay level
           ::SetPixel(Handle,x_cnt,y_cnt,TColor(RGB(colorvalue,colorvalue,colorvalue)));
          break;
        case 1:
           colorvalue=Frame_RGB[x_cnt][y_cnt].flag;
           ::SetPixel(Handle,x_cnt,y_cnt,TColor(RGB(Group[colorvalue].R_value
                         ,Group[colorvalue].G_value,Group[colorvalue].B_value)));
          break;
      }

    }
}
long int  __fastcall TConverter::Get_Group_Color(int value)
{
  return(RGB(Group[value].R_value,Group[value].G_value,Group[value].B_value));
}
