//---------------------------------------------------------------------------

#pragma hdrstop
#include "PWD.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)

#include <vcl.h>
#include <math.h>
#pragma hdrstop
#define Precision  1e-10
#define Precision2  1e-10
#define iterations 50
#define matrix_size 31
//PWD  Ω@¦vഫ  920303 Miles Wang
//---------------------------------------------------------------------------
#pragma package(smart_init)
TPWD *PWD;
__fastcall TPWD::TPWD()
{
}
//---------------------------------------------------------
__fastcall TPWD::~TPWD()
{

}

int __fastcall TPWD::Power_Method()    //Power Method @ ,~TConverter
{
  int count1,count2,count3,flag;
  double phi,si;


  for (count1=1; count1<=matrix_size; count1++)
  {
      eigen_matrix[count1]=1.0/sqrt(count1);
  }
  flag=-1;
  count3=1;

  while (flag==-1 && count3<=iterations)
  {
    eigen_value=0.0;
    for (count1=0; count1<matrix_size; count1++)
    {
      eigen_vector[count1]=0.0;
      for (count2=0; count2<matrix_size; count2++)
        eigen_vector[count1] +=  buffer[count1][count2]*eigen_matrix[count2];

      if (fabs(eigen_vector[count1])>fabs(eigen_value))
        eigen_value=eigen_vector[count1];
    }
    if (fabs(eigen_value) < Precision)
      flag=0;
    else
    {
      for (count1=0; count1< matrix_size; count1++)
       eigen_vector[count1] /= eigen_value;

      phi=0.0;

      for (count1=0; count1<matrix_size; count1++)
      {
        si=fabs(eigen_vector[count1]-eigen_matrix[count1]);
        if (si>phi)
          phi=si;
      }

      if (phi<Precision2)
        flag=1;
      else
      {
        for (count1=0; count1<matrix_size; count1++)
          eigen_matrix[count1]=eigen_vector[count1];
        count3++;
      }

    }
  }
  return(flag);
} //PWM()

double __fastcall TPWD::Get_Eigen_vector(int flag)
{
   return(eigen_matrix[flag]);
}

